<template>
  <div class="navigation">
    <Select :options="featureArray" v-model="selectedFeature"/>
  </div>
  <div class="features">
    <Feature :text="swarmResponse" orchestrator="Docker Swarm" icon="swarm.png" />
    <Feature :text="k8sResponse" orchestrator="Kubernetes" icon="k8s.png"  />
  </div>
</template>

<script>
import { ref, watch } from 'vue'
import { getSwarmFeature, getK8sFeature } from '../services/apiRequests'
import features from '../const/features';
import Feature from './Feature';
import Select from './Select';

export default {
  name: 'Main',
  components: {Select, Feature},
  setup() {
    const swarmResponse = ref()
    const k8sResponse = ref()
    const selectedFeature = ref({id: null, label: 'select option'})
    const featureArray = Object.entries(features).map((feature) => ({
      id: feature[0],
      label: feature[1]
    }))

    async function getFeature() {
      if (!selectedFeature.value || !selectedFeature.value.id) return
      const feature = selectedFeature.value.id

      try {
        const { data } = await getSwarmFeature(feature)
        swarmResponse.value = data
      } catch (e) {
        console.error(e)
        swarmResponse.value = ''
      }

      try {
        const { data }  = await getK8sFeature(feature)
        k8sResponse.value = data
      } catch (e) {
        console.error(e)
        k8sResponse.value = ''
      }
    }

    watch(selectedFeature, () => getFeature())

    return { swarmResponse, k8sResponse, featureArray, selectedFeature }
  }
}
</script>
<style scoped>
.features {
  display: flex;
  justify-content: center;
}

.navigation {
  display: flex;
  justify-content: center;
  padding: 3rem 0 2rem 0;
}

.option {
  padding: 0.125rem 0.5rem;
}
</style>